#ifndef _AOTTOOLS_H_
#define _AOTTOOLS_H_

#include "Psapi.h"

HICON GetIconFromHWnd(HWND hWnd, BOOL bSmallIcon);

typedef struct tagADDMONITOR
{
    int currentIndex;
} ADDMONITOR, * LPADDMONITOR;

// CMonitor 

class CMonitor : public CObject
{
public:
    //construction destruction
    CMonitor();
    CMonitor(const CMonitor& monitor);
    virtual ~CMonitor();

    //operations
    void Attach(const HMONITOR hMonitor);
    HMONITOR Detach();

    //properties
    BOOL IsOnMonitor(const POINT pt) const;
    BOOL IsOnMonitor(const CWnd* pWnd) const;
    BOOL IsOnMonitor(const LPRECT lprc) const;

    void GetMonitorRect(LPRECT lprc) const;
    void CenterRectToMonitor(LPRECT lprc, const BOOL UseWorkAreaRect = TRUE) const;
    void CenterWindowToMonitor(CWnd* const pWnd, const BOOL UseWorkAreaRect = TRUE) const;
    void GetWorkAreaRect(LPRECT lprc) const;
    //operators
    operator HMONITOR() const
    {
        return this == NULL ? NULL : m_hMonitor;
    }

    BOOL operator ==(const CMonitor& monitor) const
    {
        return m_hMonitor == (HMONITOR)monitor;
    }

    BOOL operator !=(const CMonitor& monitor) const
    {
        return !(*this == monitor);
    }

    void operator =(const CMonitor& monitor)
    {
        m_hMonitor = (HMONITOR)monitor;
    }


    UINT AOT_DISP;
private:
    HMONITOR m_hMonitor;
};

void DeleteMonitors();
void RefreshMonitors();

BOOL CALLBACK AddMonitorsCallBack(HMONITOR hMonitor, // handle to display monitor
    HDC hdcMonitor, // handle to monitor DC
    LPRECT lprcMonitor, // monitor intersection rectangle
    LPARAM dwData       // data
    );

#endif

extern CObArray m_MonitorArray;