// SettingsDialogMisc.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "../AOTHook/resource.h"    // main symbols
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "registry.h"
#include "MainHelperQ.h"
#include "GdiplusWrapper.h"
#include "AutoUpdater.h"
#include "desktopCalendar.h"
#include "SettingsDialogMisc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogMisc
IMPLEMENT_DYNAMIC(CSettingsDialogMisc, CPropertyPage)

CSettingsDialogMisc::CSettingsDialogMisc() : CPropertyPage(CSettingsDialogMisc::IDD)
{
    m_uXPos = 0;
    m_uYPos = 0;
    m_nTransparency = 0;
    m_nBackgroundTransparency = 0;
    m_weekStartOnSunday = 0;
    m_enableCalendar = 0;
}

CSettingsDialogMisc::~CSettingsDialogMisc()
{
}

void CSettingsDialogMisc::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_SAMPLE_TEXT, m_stText);
    DDX_Text(pDX, IDC_XPOS, m_uXPos);
    DDX_Text(pDX, IDC_YPOS, m_uYPos);
    DDX_Slider(pDX, IDC_TRANSPARENCY, m_nTransparency);
    DDX_Check(pDX, IDC_BACKGROUNDTRANSPARENCY, m_nBackgroundTransparency);
    DDX_Check(pDX, IDC_WEEKSTARTONSUNDAY, m_weekStartOnSunday);
    DDX_Check(pDX, IDC_ENABLECALENDAR, m_enableCalendar);
    DDX_Control(pDX, IDC_STARTUP, m_chkStartup);
    DDX_Control(pDX, IDC_THISUSER, m_radioThisUser);
    DDX_Control(pDX, IDC_ALLUSERS, m_radioAllUsers);
    DDX_Control(pDX, IDC_EXITAFTER, m_chkExitAfter);
    DDX_Control(pDX, IDC_USETIMER, m_chkUseTimer);
    DDX_Control(pDX, IDC_MINUTES, m_editMinutes);
    DDX_Control(pDX, IDC_SPINHOURS, m_spinHours);
    DDX_Control(pDX, IDC_SPINMINUTES, m_spinMinutes);
    DDX_Control(pDX, IDC_HOURS, m_editHours);
    DDX_Control(pDX, IDC_UPDATE, m_chkUpdate);
    DDX_Control(pDX, IDC_CHANGELANGUAGE, m_cbxLanguage);
}

BOOL CSettingsDialogMisc::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    translate();

    // Initialize or reset dialog controls.
    ResetMainDialog();

    //Update automatic
    iUpdate = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Update"), FALSE);

    CSliderCtrl* pSlider = (CSliderCtrl*)GetDlgItem(IDC_TRANSPARENCY);
    pSlider->SetRange(0, 255, true);
    pSlider->SetPos(m_nTransparency);

    m_chkStartup.SetCheck(iStartup);
    m_radioThisUser.SetCheck(iThisUser);
    m_radioAllUsers.SetCheck(!iThisUser);
    m_chkUpdate.SetCheck(iUpdate);

    if (iStartup == 0)
    {
        m_radioThisUser.EnableWindow(false);
        m_radioAllUsers.EnableWindow(false);
    }

    m_chkExitAfter.SetCheck(iExitAfter);
    m_chkUseTimer.SetCheck(iUseTimer);

    CString cstrMinutes, cstrHours;

    cstrHours.Format(_T("%d"), iMinutes / 60);
    m_editHours.SetWindowText(cstrHours);

    cstrMinutes.Format(_T("%d"), iMinutes % 60);
    m_editMinutes.SetWindowText(cstrMinutes);

    OnBnClickedExitafter();

    OnBnClickedUsetimer();

    m_spinHours.SetBuddy((CWnd *)&m_editHours);
    m_spinHours.SetRange(0, 24);

    m_spinMinutes.SetBuddy((CWnd *)&m_editMinutes);
    m_spinMinutes.SetRange(0, 59);

    CFileFind finder;
    TCHAR buffer[MAX_PATH + 1];
    CString directory = _T("");
    CString name = _T("");
    CString language = _T("");

    GetModuleFileName(theApp.m_hInstance, buffer, MAX_PATH);
    directory.Format(_T("%s"), buffer);
    directory = directory.Left(directory.ReverseFind('\\') + 1);
    name.Format(_T("%s"), buffer);
    name = name.Right(name.GetLength() - name.ReverseFind('\\') - 1);
    name = name.Left(name.ReverseFind('.'));

    m_cbxLanguage.AddString(_T("en"));
    m_cbxLanguage.SetCurSel(0);
    BOOL bWorking = finder.FindFile(directory + name + _T("_*.ini"));
    int i = 0;
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        language = finder.GetFilePath();
        language = language.Right(language.GetLength() - language.ReverseFind('_') - 1);
        language = language.Left(language.ReverseFind('.'));
        if (m_cbxLanguage.FindStringExact(0, language) == CB_ERR)
        {
            m_cbxLanguage.AddString(language);
            i++;
        }
        if (language.Compare(Language) == 0)
        {
            m_cbxLanguage.SetCurSel(i);
        }
    }


    if (iUpdate == TRUE)
    {
        CString buf;
        CAutoUpdater updater;
        CAutoUpdater::ErrorType err = updater.CheckForUpdate(_T("http://systrayplay.free.fr/"));
        switch (err)
        {
            case CAutoUpdater::Success:
                buf = m_Helper.MyLoadString(IDS_UPDATEOK);
                AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
//                ::PostMessage(pFrame->m_hWnd, WM_DESTROY, 0, 0);
                break;
            case CAutoUpdater::UpdateNotRequired:
                break;
            case CAutoUpdater::UpdateNotComplete:
                buf = m_Helper.MyLoadString(IDS_UPDATEKO);
                AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
                break;
            case CAutoUpdater::NoExecutableVersion:
                buf = m_Helper.MyLoadString(IDS_UPDATENOEXECUTABLEVERSION);
                AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
                break;
            default:
                buf = m_Helper.MyLoadString(IDS_UPDATECONNECTFAILED);
                AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
                break;
        }
    }

    UpdateData(FALSE);

    return TRUE;
}

BOOL CSettingsDialogMisc::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}
void CSettingsDialogMisc::OnOK()
{
    UpdateData(TRUE);

    CString cstrMinutes, cstrHours;

    iStartup = m_chkStartup.GetCheck();
    iThisUser = m_radioThisUser.GetCheck();
    iExitAfter = m_chkExitAfter.GetCheck();
    iUseTimer = m_chkUseTimer.GetCheck();

    m_editMinutes.GetWindowText(cstrMinutes);
    m_editHours.GetWindowText(cstrHours);
    iUpdate = m_chkUpdate.GetCheck();

    if (iUseTimer == 1 && cstrMinutes != _T(""))
    {
        iMinutes = _tstoi(cstrMinutes) + (_tstoi(cstrHours) * 60);
    }
    else
        iMinutes = 0;
    CString tmp;

    m_cbxLanguage.GetLBText(m_cbxLanguage.GetCurSel(), tmp);
    Language = tmp;

    CPropertyPage::OnOK();
}
BEGIN_MESSAGE_MAP(CSettingsDialogMisc, CPropertyPage)
    ON_WM_ERASEBKGND()
    ON_BN_CLICKED(IDC_FONT_BTN, OnFontBtn)
    ON_BN_CLICKED(IDC_COLOR_BTN, OnColorBtn)
    ON_EN_CHANGE(IDC_XPOS, OnEnableApply)
    ON_EN_CHANGE(IDC_YPOS, OnEnableApply)
    ON_BN_CLICKED(IDC_BACKGROUNDTRANSPARENCY, OnEnableApply)
    ON_BN_CLICKED(IDC_ENABLECALENDAR, OnBnClickedEnablecalendar)
    ON_BN_CLICKED(IDC_WEEKSTARTONSUNDAY, OnEnableApply)
    ON_BN_CLICKED(IDC_USETIMER, OnBnClickedUsetimer)
    ON_BN_CLICKED(IDC_EXITAFTER, OnBnClickedExitafter)
    ON_BN_CLICKED(IDC_STARTUP, OnBnClickedStartup)
    ON_CBN_SELCHANGE(IDC_CHANGELANGUAGE, OnEnableApply)
    ON_NOTIFY(NM_CUSTOMDRAW, IDC_TRANSPARENCY, OnEnableApply)
    ON_BN_CLICKED(IDC_THISUSER, OnEnableApply)
    ON_BN_CLICKED(IDC_UPDATE, OnEnableApply)
    ON_EN_CHANGE(IDC_HOURS, OnEnableApply)
    ON_EN_CHANGE(IDC_MINUTES, OnEnableApply)
    ON_NOTIFY(UDN_DELTAPOS, IDC_SPINHOURS, OnEnableApply)
    ON_NOTIFY(UDN_DELTAPOS, IDC_SPINMINUTES, OnEnableApply)
END_MESSAGE_MAP()

void CSettingsDialogMisc::translate()
{
    if (m_hWnd != NULL)
    {
        m_Helper.translateWindowText(this, IDD_SETTINGS_MISC);
        m_Helper.translateDlgItemText(this, IDC_CALENDAR);
        m_Helper.translateDlgItemText(this, IDC_ENABLECALENDAR);
        m_Helper.translateDlgItemText(this, IDC_POSX);
        m_Helper.translateDlgItemText(this, IDC_POSY);
        m_Helper.translateDlgItemText(this, IDC_FONT);
        m_Helper.translateDlgItemText(this, IDC_LCOLOR);
        m_Helper.translateDlgItemText(this, IDC_LTRANSPARENCY);
        m_Helper.translateDlgItemText(this, IDC_WEEKSTARTONSUNDAY);
        m_Helper.translateDlgItemText(this, IDC_BACKGROUNDTRANSPARENCY);
        m_Helper.translateDlgItemText(this, IDC_STARTUP);
        m_Helper.translateDlgItemText(this, IDC_THISUSER);
        m_Helper.translateDlgItemText(this, IDC_ALLUSERS);
        m_Helper.translateDlgItemText(this, IDC_EXITAFTER);
        m_Helper.translateDlgItemText(this, IDC_USETIMER);
        m_Helper.translateDlgItemText(this, IDC_EHOURS);
        m_Helper.translateDlgItemText(this, IDC_EMINUTES);
        m_Helper.translateDlgItemText(this, IDC_UPDATE);
        m_Helper.translateDlgItemText(this, IDC_LLANGUAGE);

        m_Helper.storeTranslation(IDS_LAOT);
        m_Helper.storeTranslation(IDS_LTRAYME);
        m_Helper.storeTranslation(IDS_LSENDTOMONITOR);
        m_Helper.storeTranslation(IDS_LCAPS);
        m_Helper.storeTranslation(IDS_LTAB);
        m_Helper.storeTranslation(IDS_LNEWTAB);
        m_Helper.storeTranslation(IDS_LEXTENDEDFUNCTIONS);
        m_Helper.storeTranslation(IDS_LRENAMEWND);
    }
}

void CSettingsDialogMisc::ResetMainDialog()
{
    m_uXPos = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("StartX"), 100);
    m_uYPos = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("StartY"), 100);
    m_szFontName = CRegistry::GetRegString(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Font Name"), _T("Monotype Corsiva"));
    m_nFontSize = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Text Size"), 24);
    m_crTextColor = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Text Color"), (INT)RGB(0, 255, 0));
    m_crBackColor = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Back Ground Color"), (INT)RGB(255, 255, 255));
    m_nTransparency = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Transparency"), 88);
    m_nBackgroundTransparency = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("BackgroundTransparency"), 0);
    m_weekStartOnSunday = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("WeekStartOnSunday"), 0);
    m_enableCalendar = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("EnableCalendar"), 0);

    GetDlgItem(IDC_XPOS)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_YPOS)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_FONT_BTN)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_COLOR_BTN)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_TRANSPARENCY)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_BACKGROUNDTRANSPARENCY)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_WEEKSTARTONSUNDAY)->EnableWindow(m_enableCalendar);

    //// Get startup options.
    iStartup = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("RunAtStartup"), 1);
    iThisUser = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("ThisOrAllUsers"), 1);
    iExitAfter = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("ExitAfter"), 0);
    iUseTimer = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("UseTimer"), 0);
    iMinutes = (int)CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("TimerMinutes"), 0);

    Language = CRegistry::GetRegString(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Language"), _T(""));
}

void CSettingsDialogMisc::OnFontBtn()
{
    CFontDialog dlg(NULL);

    CClientDC dc(this);
    dlg.m_cf.lpLogFont->lfHeight = -MulDiv(m_nFontSize, dc.GetDeviceCaps(LOGPIXELSY), 72);
    dlg.m_cf.rgbColors = m_crTextColor;
    dlg.m_cf.Flags |= CF_INITTOLOGFONTSTRUCT;
    _tcscpy(dlg.m_cf.lpLogFont->lfFaceName, m_szFontName);
    if (dlg.DoModal() == IDOK)
    {
        m_szFontName = dlg.GetFaceName();
        m_nFontSize = dlg.GetSize() / 10;
        m_crTextColor = dlg.GetColor();
        DrawSampleText();
        SettingsDialog->m_btnApply.EnableWindow();
    }
}

void CSettingsDialogMisc::OnColorBtn()
{
    CColorDialog dlg;
    dlg.m_cc.Flags |= CC_RGBINIT;
    dlg.m_cc.rgbResult = m_crBackColor;
    if (dlg.DoModal() == IDOK)
    {
        m_crBackColor = dlg.GetColor();
        DrawSampleText();
        SettingsDialog->m_btnApply.EnableWindow();
    }
}

void CSettingsDialogMisc::OnEnableApply()
{
    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogMisc::OnBnClickedEnablecalendar()
{
    UpdateData(true);
    GetDlgItem(IDC_XPOS)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_YPOS)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_FONT_BTN)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_COLOR_BTN)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_TRANSPARENCY)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_BACKGROUNDTRANSPARENCY)->EnableWindow(m_enableCalendar);
    GetDlgItem(IDC_WEEKSTARTONSUNDAY)->EnableWindow(m_enableCalendar);
    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogMisc::DrawSampleText()
{
    CWnd* pWnd;
    pWnd = GetDlgItem(IDC_SAMPLE_TEXT);
    if (pWnd)
    {
        CDC* pDC = pWnd->GetDC();
        HDC hDC = CreateCompatibleDC(::GetWindowDC(pWnd->m_hWnd));

        CRect ClientRect;
        pWnd->GetClientRect(&ClientRect);

        HBITMAP bm = CreateCompatibleBitmap(pDC->m_hDC, ClientRect.Width(), ClientRect.Height());
        SelectObject(hDC, bm);
        CFont font;
        font.CreateFont(m_nFontSize, 0, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET, 0, 0, 0, FF_DONTCARE, m_szFontName);
        CDC::FromHandle(hDC)->SelectObject(&font);
        TEXTMETRIC tmText;
        CDC::FromHandle(hDC)->GetTextMetrics(&tmText);
        CDC::FromHandle(hDC)->SetBkMode(TRANSPARENT);
        CDC::FromHandle(hDC)->SetTextColor(m_crTextColor);

        INT m_nCharWidth = (tmText.tmMaxCharWidth + 2 * tmText.tmAveCharWidth);
        INT m_nCharHeight = tmText.tmHeight + 4;

        CRect TextRect;
        int nStartX = (ClientRect.Width() - m_nCharWidth * 6) / 2;
        if (nStartX < 0)
            nStartX = 2;
        int nStartY = (ClientRect.Height() - m_nCharHeight) / 2;
        if (nStartY < 0)
            nStartY = 2;

        TextRect.left = nStartX;
        TextRect.top = nStartY ;
        TextRect.right = TextRect.left + m_nCharWidth * 6;
        TextRect.bottom = TextRect.top + m_nCharHeight;
        CBrush Brush;
        CDC::FromHandle(hDC)->FillSolidRect(&ClientRect, m_crBackColor);

        CDC::FromHandle(hDC)->DrawText(m_Helper.MyLoadString(IDS_EXEMPLE), &TextRect, DT_LEFT | DT_VCENTER | DT_SINGLELINE);

        if (gdiplusWrapper.IsInitialized())
        {
            Graphics* myGraphics = new Graphics(pDC->m_hDC);
            Bitmap* pBmp = new Bitmap(bm, NULL);
            myGraphics->DrawImage(pBmp, 0, 0, ClientRect.Width(), ClientRect.Height());
            delete pBmp;
            delete myGraphics;
        }
        else
            pDC->StretchBlt(ClientRect.left, ClientRect.top, ClientRect.Width(), ClientRect.Height(), CDC::FromHandle(hDC), 0, 0, ClientRect.Width(), ClientRect.Height(), SRCCOPY);
    }
}

void CSettingsDialogMisc::ApplyChanges()
{
    CRegistry::SetRegString(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Font Name"), m_szFontName);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Text Size"), m_nFontSize);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Text Color"), m_crTextColor);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Back Ground Color"), m_crBackColor);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Transparency"), m_nTransparency);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("BackgroundTransparency"), m_nBackgroundTransparency);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("WeekStartOnSunday"), m_weekStartOnSunday);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("EnableCalendar"), m_enableCalendar);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("StartX"), m_uXPos);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("StartY"), m_uYPos);

    CRegistry::SetRegString(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Language"), Language);
    SettingsDialog->translate();

    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("RunAtStartup"), (DWORD)iStartup);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("ThisOrAllUsers"), (DWORD)iThisUser);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("ExitAfter"), (DWORD)iExitAfter);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("UseTimer"), (DWORD)iUseTimer);
    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("TimerMinutes"), (DWORD)iMinutes);

    CRegistry::SetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("Update"), (DWORD)iUpdate);

    // Remove desktopCalendar from the startup portion of the registry.
    CRegistry::RegDelete(_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), _T("desktopCalendar"), _T(""), HKEY_LOCAL_MACHINE);
    CRegistry::RegDelete(_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), _T("desktopCalendar"), _T(""), HKEY_CURRENT_USER);

    // If the chose to start the app on system startup, add it back to the registry.
    if (iStartup == 1)
    {
        TCHAR path[MAX_PATH];
        ::GetModuleFileName(AfxGetApp()->m_hInstance, path, MAX_PATH);
        CString cstrStartupApp;
        cstrStartupApp.Format(_T("\"%s\""), path);
        if (iThisUser == 1)
        {
            // For this user only.
            CRegistry::SetRegString(_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), _T("desktopCalendar"), cstrStartupApp);
        }
        else
        {
            // For all users.
            CRegistry::SetRegString(_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), _T("desktopCalendar"), cstrStartupApp, HKEY_LOCAL_MACHINE);
        }
    }
}

void CSettingsDialogMisc::OnBnClickedUsetimer()
{
    if (m_chkUseTimer.GetCheck() == 0)
    {
        m_editHours.EnableWindow(false);
        m_editMinutes.EnableWindow(false);
        m_chkExitAfter.EnableWindow();
    }
    else
    {
        m_editHours.EnableWindow();
        m_editMinutes.EnableWindow();
        m_chkExitAfter.SetCheck(0);
        m_chkExitAfter.EnableWindow(false);
    }
    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogMisc::OnBnClickedStartup()
{
    m_radioThisUser.EnableWindow(m_chkStartup.GetCheck());
    m_radioAllUsers.EnableWindow(m_chkStartup.GetCheck());
    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogMisc::OnBnClickedExitafter()
{
    if (m_chkExitAfter.GetCheck() == 1)
    {
        m_chkUseTimer.SetCheck(0);
        m_chkUseTimer.EnableWindow(false);
        m_editHours.EnableWindow(false);
        m_editMinutes.EnableWindow(false);
    }
    else
        m_chkUseTimer.EnableWindow();
    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogMisc::OnEnableApply(NMHDR* pNMHDR, LRESULT* pResult)
{
    SettingsDialog->m_btnApply.EnableWindow();
}
