#ifndef SETTINGSDIALOGQUEUEIMAGES_H
#define SETTINGSDIALOGQUEUEIMAGES_H

// Bote de dialogue CDialogYesNoAll

class CDialogYesNoAll : public CDialog
{
    DECLARE_DYNAMIC(CDialogYesNoAll)

public:
    CDialogYesNoAll(CString filen);
    virtual ~CDialogYesNoAll();
    afx_msg void DrawPreview();
    void translate();
    int GetResult();

    enum
    {
        IDD = IDD_YESNOALL
    };

protected:
    afx_msg void OnBnClickedYes();
    afx_msg void OnBnClickedNo();
    afx_msg void OnBnClickedYesToAll();
    afx_msg void OnBnClickedNoToAll();
    virtual void DoDataExchange(CDataExchange* pDX);  // Prise en charge DDX/DDV
    afx_msg BOOL OnInitDialog();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);

    DECLARE_MESSAGE_MAP()

    CStaticCtrl m_picPreview;   /* Preview window. */
    CStatic m_stType;           /* BitsPerPixel of the image. */
    CStatic m_stHeight;         /* Height of the image in pixels. */
    CStatic m_stWidth;          /* Width of the image in pixels. */
    int result;
    CString filename;
};

// Bote de dialogue CSettingsDialogQueueImages

class CSettingsDialogQueueImages : public CPropertyPage
{
    DECLARE_DYNAMIC(CSettingsDialogQueueImages)

public:
    CSettingsDialogQueueImages();
    virtual ~CSettingsDialogQueueImages();
    afx_msg void DrawPreview();
    void ResetMainDialog();
    void ApplyChanges();
    void translate();
    void QueueImage(CString cstrImagePath, int* result = NULL);
    CDialogYesNoAll* dialogYesNoAll;

    enum
    {
        IDD = IDD_SETTINGS_QUEUE_IMAGES
    };

protected:
    HTREEITEM GetItem(CString path);
    CString GetItemPath(HTREEITEM hItem);
    bool PopulateTree(CString sPath, HTREEITEM hParent);
    HTREEITEM InsertItem(HTREEITEM hParent, HTREEITEM hAfter, NETRESOURCE *const pNetResource, CString sText, int iImage, int iImageSelected = -1);
    virtual BOOL DestroyWindow();
    afx_msg void OnOK();
    virtual void DoDataExchange(CDataExchange* pDX);  // Prise en charge DDX/DDV
    afx_msg BOOL OnInitDialog();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg bool EnumNetwork(HTREEITEM hParent);
    afx_msg void OnItemexpandingTree(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnBnClickedAdd();
    afx_msg void OnBnClickedAddAll();
    afx_msg void OnBnClickedAddAllRecursively();
    afx_msg BOOL OnSetActive();
    afx_msg void OnKeyDown(NMHDR* pNMHDR, LRESULT* pResult);
    void Refresh(HTREEITEM item);
    void FillList();

    DECLARE_MESSAGE_MAP()

    CStringArray m_cstrSearch;
    CString m_cstrBrowsePath;
    CTreeCtrl m_Tree;
    CListBox m_lbBrowseList;    /* List of images in the browsed to folder. */
    CStaticCtrl m_picPreview;   /* Preview window. */
    CStatic m_stType;           /* BitsPerPixel of the image. */
    CStatic m_stHeight;         /* Height of the image in pixels. */
    CStatic m_stWidth;          /* Width of the image in pixels. */
    CImageList m_ImageListTree; /* Item in the Tree image list */
    HTREEITEM m_hNetworkRoot;   /* Network neighbourhood root */
};

int GetWPPositionByImageSize(CString cstrImagePath, UINT iHorzRes, UINT iVertRes);

#endif
